function [sys,x0,str,ts] = model(t,x,u,flag,NN,NetDef,W1,W2)


switch flag,

  case 0
    [sys,x0,str,ts] = mdlInitializeSizes(NN,NetDef); % Initialization

  case 2  
    sys=mdlUpdate(t,x,u,W1,W2);  %Update   
    
  case 3
    sys = mdlOutputs(t,x,u); % Calculate outputs

  case {1, 4, 9} % Unused flags
    sys = [];

  otherwise
    error(['unhandled flag = ',num2str(flag)]); % Error handling
end

%==============================================================
% Initialization
%==============================================================

function [sys,x0,str,ts] = mdlInitializeSizes(NN,NetDef)

global na nb hidden L_hidden H_hidden

na=NN(1);
nb=NN(2);
hidden=length(NetDef(1,:));
L_hidden = find(NetDef(1,:)=='L')';  
H_hidden = find(NetDef(1,:)=='H')';  
sizes = simsizes;

sizes.NumContStates  = 0;
sizes.NumDiscStates  = na+nb;
sizes.NumOutputs     = 1;
sizes.NumInputs      = 2;
sizes.DirFeedthrough = 1;
sizes.NumSampleTimes = 1;

sys = simsizes(sizes); 

x0  = zeros(1,na+nb);
str = [];          
ts  = [0.2 0];  



% end mdlInitializeSizes

%=============================================================================
% mdlUpdate
%=============================================================================

function sys=mdlUpdate(t,x,u,W1,W2)

global na nb hidden L_hidden H_hidden

wej=[u(2);u(1);x(1:na-1);x(na+1:end-1)];
fi=W1(:,1:na+nb)*wej+W1(:,na+nb+1)*ones(1,1);
z1(H_hidden,1)=tansig(fi(H_hidden));
z1(L_hidden,1)=fi(L_hidden);
wyj=W2(1:hidden)*z1(:,1)+W2(:,hidden+1)*ones(1,1);
sys=[u(1);x(1:na-1);wyj;x(na+1:end-1)];


% end mdlUpdate

%==============================================================
% Calculate outputs
%==============================================================

function sys = mdlOutputs(t,x,u)

global na

sys=x(na+1);

% end of mdlOutputs.